#!/bin/sh

source ./bfw

mkdir -pv $TEMPFILES || exit 1

distfile http://www.globus.org/ftppub/gt5/5.0/5.0.3/installers/src/gt5.0.3-all-source-installer.tar.bz2 - d604c30eec4171fa23bbf2512eac134d2c7107ab && \
distfile http://vdt.cs.wisc.edu/patches/5.0.2/011__gss_assist_gridmap.diff - e8211ee3ed65f53957265807f52c5fa4eee21af3 && \
distfile http://vdt.cs.wisc.edu/patches/5.0.2/089__teragrid-pbs-fixes.diff - 926ed7ad6ada3fdfee0fe9158efbb61123d7484b && \
distfile http://vdt.cs.wisc.edu/patches/5.0.2/117__job_status.diff         - 99fa7213f15ffc269c0c60f0cffd2c3b57c80cfe && \
distfile http://vdt.cs.wisc.edu/patches/5.0.2/211__fix_seg_wrapper.diff    - e30a6c4697f3996c7d465780b675acea8400c794 || exit 1

cd $TEMPFILES

tar --no-same-owner -x -f $DISTFILES/gt5.0.3-all-source-installer.tar.bz2
cd gt5.0.3-all-source-installer
patch -p0 -i $DISTFILES/011__gss_assist_gridmap.diff
patch -p0 -i $DISTFILES/089__teragrid-pbs-fixes.diff
patch -p0 -i $DISTFILES/117__job_status.diff
patch -p0 -i $DISTFILES/211__fix_seg_wrapper.diff

JAVA_HOME=/usr/lib/jvm/java-1.6.0 \
CFLAGS="-fPIC" \
./configure \
  --prefix=/opt/globus \
  --enable-java \
  --enable-wsgram-pbs \
  --with-gsiopensshargs="--with-pam --with-md5-passwords --with-tcp-wrappers --with-privsep-user=sshd --with-privsep-path=/var/empty/sshd --with-libedit --with-session-hooks --with-xauth=/usr/bin/xauth --with-ssl-engine" 
make
make install

mv /opt/globus/lib/perl/Pod /opt/globus/lib/perl/Pod.unused
for i in `find /opt/globus/var/lib/perl -type f` ; do
  j=`echo $i | sed 's:^/opt/globus/var/lib:/opt/globus/lib:'`
  mv -v $i $j
done
rm -rf /opt/globus/var/lib/perl
rmdir /opt/globus/var/lib

rm -rf gt5.0.3-all-source-installer
