#!/bin/sh

source ./bfw

mkdir -pv $TEMPFILES || exit 1

distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.build.common-cpp HEAD glite-build-common-cpp.tar.bz2

distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcas glite-security-lcas_R_1_4_0_2 glite-security-lcas-1.4.0.2.tar.bz2
distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcas-plugins-basic glite-security-lcas-plugins-basic_R_1_3_3_4 glite-security-lcas-plugins-basic-1.3.3.4.tar.bz2
distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcas-plugins-check-executable glite-security-lcas-plugins-check-executable_R_1_2_1_5 glite-security-lcas-plugins-check-executable-1.2.1.5.tar.bz2
distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcas-plugins-voms glite-security-lcas-plugins-voms_R_1_3_5_4 glite-security-lcas-plugins-voms-1.3.5.4.tar.bz2

distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcmaps glite-security-lcmaps_R_1_4_26_1 glite-security-lcmaps-1.4.26.1.tar.bz2
distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcmaps-plugins-basic glite-security-lcmaps-plugins-basic_R_1_4_1_3 glite-security-lcmaps-plugins-basic-1.4.1.3.tar.bz2
distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcmaps-plugins-verify-proxy glite-security-lcmaps-plugins-verify-proxy_R_1_4_7_2 glite-security-lcmaps-plugins-verify-proxy-1.4.7.2.tar.bz2
distcvs anonymous@glite.cvs.cern.ch:/cvs/glite org.glite.security.lcmaps-plugins-voms glite-security-lcmaps-plugins-voms_R_1_4_0_3 glite-security-lcmaps-plugins-voms-1.4.0.3.tar.bz2

export GLOBUS_LOCATION=/opt/globus
source /opt/globus/etc/globus-user-env.sh

cd $TEMPFILES

tar xf $DISTFILES/glite-security-lcas-1.4.0.2.tar.bz2
cd glite-security-lcas-1.4.0.2

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/{globus,glite}.m4
cd ..

sed 's:^SUBDIRS = .*$:& interface:' -i Makefile.am
sed 's:^#\(.*interface/Makefile.*\)$:\1:' -i configure.ac

./bootstrap

./configure --prefix=/opt/glite --with-globus-nothr-flavor=gcc64dbg --with-globus-thr-flavor=gcc64dbgpthr
make && make install

cd ..
rm -rf glite-security-lcas-1.4.0.2


tar xf $DISTFILES/glite-security-lcas-plugins-basic-1.3.3.4.tar.bz2
cd glite-security-lcas-plugins-basic-1.3.3.4

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/{globus,glite,gridlist}.m4
cd ..

./bootstrap

./configure --prefix=/opt/glite --with-globus-nothr-flavor=gcc64dbg --with-globus-thr-flavor=gcc64dbgpthr
make && make install

cd ..
rm -rf glite-security-lcas-plugins-basic-1.3.3.4


tar xf $DISTFILES/glite-security-lcas-plugins-check-executable-1.2.1.5.tar.bz2
cd glite-security-lcas-plugins-check-executable-1.2.1.5

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/{globus,glite}.m4
cd ..

./bootstrap

./configure --prefix=/opt/glite --with-globus-nothr-flavor=gcc64dbg --with-globus-thr-flavor=gcc64dbgpthr
make && make install

cd ..
rm -rf glite-security-lcas-plugins-check-executable-1.2.1.5

tar xf $DISTFILES/glite-security-lcas-plugins-voms-1.3.5.4.tar.bz2
cd glite-security-lcas-plugins-voms-1.3.5.4

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/{globus,glite,gridlist,gridsite,glite_security}.m4
cd ..

./bootstrap

./configure --prefix=/opt/glite --with-gridsite-prefix=/opt/glite \
  --with-gridsite-ssl=system \
  --with-globus-nothr-flavor=gcc64dbg --with-globus-thr-flavor=gcc64dbgpthr
make && make install

cd ..
rm -rf glite-security-lcas-plugins-voms-1.3.5.4

tar xf $DISTFILES/glite-security-lcmaps-1.4.26.1.tar.bz2
cd glite-security-lcmaps-1.4.26.1

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/{globus,glite,glite_security,lcmaps}.m4
cd ..

sed 's!/opt/glite/lib!/opt/glite/lib64!' -i interface/lcmaps_defines.h

patch -p0 <<'END'
--- src/grid_credential_handling/gsi_handling/lcmaps_voms_attributes.c.orig	2011-03-06 00:57:15.297489981 +0200
+++ src/grid_credential_handling/gsi_handling/lcmaps_voms_attributes.c	2011-03-06 00:59:59.849113816 +0200
@@ -389,6 +389,13 @@
       }
     }
   }
+  // We need to strdup() attribute properties the same way as it is done for FQANs
+  // or they get freed on VOMS_Destroy() and LCMAPS will see garbage instead of the values
+  for (i = 0; i < (*nattrs); i++) {
+    tmp_list[i].name = strdup(tmp_list[i].name);
+    tmp_list[i].value = strdup(tmp_list[i].value);
+    tmp_list[i].qualifier = strdup(tmp_list[i].qualifier);
+  }
   // XXX should the 'struct lcmaps_voms_generic_attr_t' differ from the voms_apic.h 
   // ' struct attribute' some time in future. Here's the place to bring them together.
   // (i.e. you'll need to replace the cast by something more appropriate)
END

./bootstrap

./configure --without-gsi-mode
make && make install && make distclean

./configure --with-globus-nothr-flavor=gcc64dbg --with-globus-thr-flavor=gcc64dbgpthr
make && make install && make distclean

cd ..
rm -rf glite-security-lcmaps-1.4.26.1

tar xf $DISTFILES/glite-security-lcmaps-plugins-basic-1.4.1.3.tar.bz2
cd glite-security-lcmaps-plugins-basic-1.4.1.3

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/{globus,glite,gridlist,lcmaps}.m4
cd ..

./bootstrap

./configure --without-gsi-mode
make && make install && make distclean

./configure --with-globus-nothr-flavor=gcc64dbg --with-globus-thr-flavor=gcc64dbgpthr
make && make install && make distclean

cd ..
rm -rf glite-security-lcmaps-plugins-basic-1.4.1.3


tar xf $DISTFILES/glite-security-lcmaps-plugins-verify-proxy-1.4.7.2.tar.bz2
cd glite-security-lcmaps-plugins-verify-proxy-1.4.7.2

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/glite.m4
cd ..

./bootstrap
./configure
make && make install

cd ..
rm -rf glite-security-lcmaps-plugins-verify-proxy-1.4.7.2

tar xf $DISTFILES/glite-security-lcmaps-plugins-voms-1.4.0.3.tar.bz2
cd glite-security-lcmaps-plugins-voms-1.4.0.3

cd project
tar --strip-components=2 -x -f $DISTFILES/glite-build-common-cpp.tar.bz2 glite-build-common-cpp/m4/{globus,glite,gridlist,glite_security,lcmaps}.m4
cd ..

./bootstrap

./configure --without-gsi-mode
make && make install && make distclean

./configure --with-globus-nothr-flavor=gcc64dbg --with-globus-thr-flavor=gcc64dbgpthr
make && make install && make distclean

cd ..
rm -rf glite-security-lcmaps-plugins-voms-1.4.0.3
